#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <time.h>

#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <errno.h>

#define _POSIX_SOURCE 1         //POSIX compliant source
#define FALSE 0
#define TRUE 1

volatile int STOP=FALSE;

int wait_flag=TRUE;                     //TRUE while no signal received
long BAUD;                      // derived baud rate from command line
long DATABITS;
long STOPBITS;
long PARITYON;
long PARITY;
int Data_Bits = 8;              // Number of data bits
int Stop_Bits = 1;              // Number of stop bits
int Parity = 0;                 // Parity as follows:
                  				// 00 = NONE, 01 = Odd, 02 = Even, 03 = Mark, 04 = Space



void sigproc()
{
		 /* NOTE some versions of UNIX will reset signal to default
		 after each call. So for portability reset signal each time */
 
		 printf("you have pressed ctrl-c\n");
}

void quitproc ()
{
   STOP = TRUE;
}

main(int argc, char *argv[])
{

   int fd;

   struct sigaction saio;               //definition of signal action
   char *buf;                       //buffer for where data is put
   struct termios oldtio, newtio;       //place for old and new port settings for serial port
   struct termios oldkey, newkey;       //place tor old and new port settings for keyboard teletype 
     
	BAUD  = B9600;

    DATABITS = CS8;
	STOPBITS = CSTOPB;
    PARITYON = 0;
    PARITY = 0;
	signal(SIGQUIT, quitproc);
    signal(SIGINT, sigproc);   
      //open the device(com port) to be non-blocking (read will return immediately)
      fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NONBLOCK);
      if (fd < 0)
      {

         exit(-1);
      }

      //install the serial handler before making the device asynchronous
      /*saio.sa_handler = signal_handler_IO;
      sigemptyset(&saio.sa_mask);   //saio.sa_mask = 0;
      saio.sa_flags = 0;
      saio.sa_restorer = NULL;
      sigaction(SIGIO,&saio,NULL);*/
      
      // allow the process to receive SIGIO
      //fcntl(tty, F_SETOWN, getpid());
      // Make the file descriptor asynchronous (the manual page says only
      // O_APPEND and O_NONBLOCK, will work with F_SETFL...)
      //fcntl(tty, F_SETFL, FASYNC);

      tcgetattr(fd,&oldtio); // save current port settings 
      // set new port settings for canonical input processing 
      newtio.c_cflag = BAUD | CRTSCTS | DATABITS | STOPBITS | PARITYON | PARITY | CLOCAL | CREAD;
      newtio.c_iflag = IGNPAR;
      newtio.c_oflag = 0;
      newtio.c_lflag = 0;       //ICANON;
      newtio.c_cc[VMIN]=1;
      newtio.c_cc[VTIME]=0;
      tcflush(fd, TCIFLUSH);
      tcsetattr(fd,TCSANOW,&newtio);
	  
	  buf = malloc(64*1024);
	  memset(buf,0,64*1024);
	  char *bufptr;
	  bufptr = buf;
	  char msg[32];
      // loop while waiting for input. normally we would do something useful here
      while (STOP==FALSE)
      {
      		struct timeval tv;
      		memset(msg,0,32);
      		write(fd,"QM\r",4);          //write 1 byte to the port
            sleep(1);
            read(fd,msg,32);
            memcpy(bufptr,msg+5,7);
            memcpy(bufptr+7,",",1);
            time_t time1 = time(NULL);
            short time_cut = (short) time1;
            gettimeofday( &tv, NULL);
            unsigned int i = sprintf(bufptr+8," %u.%u\n",tv.tv_sec,tv.tv_usec);
            bufptr+=i+8;
            printf("%s\n",msg);
            
      }  //while stop==FALSE

      
    int OUTFILE = open(*(argv+1),O_CREAT|O_WRONLY|O_TRUNC,S_IRWXU|S_IRWXG|S_IRWXO);
      
      
    write(OUTFILE,buf, bufptr-buf);
    
	close(OUTFILE);
      
    tcsetattr(fd,TCSANOW,&oldtio);
	free(buf);
    close(fd);        //close the com port


}





